#!/bin/bash

#
# this script is for log clean service
#

#!/bin/bash

echo "start del log service..."

TARGET_DIR=/logs
if [ -n "$1" ]; then
    TARGET_DIR=$1
fi

DAYS_MODIFY=3
MAX_COUNT=3

if [ -n "$2" ]; then
    DAYS_MODIFY=$2
fi
if [ -n "$3" ]; then
    MAX_COUNT=$2
fi

echo "check log root dir: $TARGET_DIR"
echo "the same log max ct: $MAX_COUNT"

function log_out(){
    echo "$(date) del log: $1"
}

function del_log_bytime(){
    if [ -z "$1" ]; then
            return
    fi
    local LOG_D=$1
#        echo "find dir: $LOG_D"
    local FILES=`find $LOG_D -mtime +${DAYS_MODIFY}`
    for log in $FILES
    do
#           echo "check log file: $log"
        ff=`fuser $log`
        if [ ${#ff} == 0 ]; then
            rm -vf $log
            log_out $log
        fi
    done
}

function del_log_byhostname(){
    if [ -z "$1" ]; then
        return
    fi
    local hh=`hostname`
    local LOG_D=$1
#   echo "find dir: $LOG_D"
    for log in `find $LOG_D -type f | grep -v "$hh"`
    do
#       echo "check log file: $log"
        rm -vf $log
        log_out $log
    done
}

function del_log_bycount(){
    if [ -z "$1" ]; then
        return
    fi
#    echo "find dir: $1"
    local LOG_D=$1
    local BASE=
    local COUNT=0
    local YEAR=`date +%Y`
    local FILES=`ls $LOG_D | sort -r`

    for logf in $FILES
    do
        log=$LOG_D/$logf
#        echo "check log file: $log"
        if [ -L $log ]; then
            continue
        fi
        if [ ! -f $log ]; then
            continue
        fi

        if [ "$BASE" != "${log%%$YEAR*}" ]; then
            BASE=${log%$YEAR*}
            COUNT=0
        fi

        COUNT=$[$COUNT + 1]
        if [ $COUNT -le $MAX_COUNT ]; then
            continue
        fi

        ff=`fuser $log`
        if [ ${#ff} == 0 ]; then
            rm -vf $log
            log_out $log
        fi
    done
}

COUNT=1
while true
do
    LOG_DIR=`find $TARGET_DIR -type d`
    for f in $LOG_DIR
    do
        del_log_byhostname $f
#        del_log_bytime $f
        del_log_bycount $f
    done
    COUNT=$[COUNT+1]
    if [ $COUNT -gt 100 ]; then
        echo >> /tmp/del_log.log
        COUNT=1
    fi
    sleep 10s
done

